do "sharetest.ado"
do "rkstat_functions.do"

/***Three different example datasets***/
use "examples/moderate_constraint.dta", clear
//use "examples/light_constraint.dta", clear
//use "examples/no_constraint.dta", clear








/*
True Elasticities:


. sum elas*

    Variable |        Obs        Mean    Std. Dev.       Min        Max
-------------+---------------------------------------------------------
   elask_tru |     18,291     .108603    .1029327   .0000932   .3863304
   elasl_tru |     18,291     .281397    .1029327   .0036696   .3899068
   elasm_tru |     18,291         .67    2.63e-08        .67        .67

*/



sort id t

/*
//Use instruments from the paper
gen INSTm = l2.m 
gen INSTk = l2.k 
gen INSTkXm = INSTm*INSTk
*/
/******************
Specification test
*******************/

//In these examples the prices are all 1, but that might not be true in your case
//See Footnote 5 and Online Appendix D.2 for details
gen logSHARE = log( Pm*M/(Py*Y) )

sharetest logSHARE k l m, test( l2.( c.k##c.m ) ) lagtest deg(4) lagdeg(1) con(i.t) //Here we control for year dummies. You can add other controls as you wish



/******************
Weak ID test
*******************/
order k l m, last
product k l m

//Calculate rk statistic
widstat_simple

//Bootstrap the percentiles of the null distribution [You should probably use more like 500 than 100---this is just a demonstration]
bspctiles_simple 500 "bsreps.dta"

sum widstat_iv widstatp_1 widstatp_2 widstatp_3 widstatp_4
